package com.ubains.rtspdemo;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Build;
import android.os.Bundle;
import android.transition.Explode;
import android.view.View;
import android.view.Window;

import com.shuyu.gsyvideoplayer.GSYVideoManager;
import com.shuyu.gsyvideoplayer.cache.CacheFactory;
import com.shuyu.gsyvideoplayer.cache.ProxyCacheManager;
import com.shuyu.gsyvideoplayer.listener.GSYSampleCallBack;
import com.shuyu.gsyvideoplayer.model.VideoOptionModel;
import com.shuyu.gsyvideoplayer.player.IjkPlayerManager;
import com.shuyu.gsyvideoplayer.player.PlayerFactory;
import com.ubains.rtspdemo.vedio.MultiSampleVideo;
import com.ubains.rtspdemo.vedio.manager.CustomManager;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import tv.danmaku.ijk.media.player.IjkMediaPlayer;

public class MutliActivity extends AppCompatActivity {

    MultiSampleVideo videoPlayer1, videoPlayer2;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            getWindow().requestFeature(Window.FEATURE_CONTENT_TRANSITIONS);
            getWindow().setEnterTransition(new Explode());
            getWindow().setExitTransition(new Explode());
        }
        setContentView(R.layout.activity_mutli);
        videoPlayer1 = findViewById(R.id.detail_player1);
        videoPlayer2 = findViewById(R.id.detail_player2);
    }

    private void init() {
        //PlayerFactory.setPlayManager(Exo2PlayerManager.class);
        //系统内核模式
        //PlayerFactory.setPlayManager(SystemPlayerManager.class);
        //ijk内核，默认模式  ijk  模式才支持RTSP 播放
        PlayerFactory.setPlayManager(IjkPlayerManager.class);

        //exo缓存模式，支持m3u8，只支持exo
        // CacheFactory.setCacheManager(ExoPlayerCacheManager.class);
        //代理缓存模式，支持所有模式，不支持m3u8等，默认
        CacheFactory.setCacheManager(ProxyCacheManager.class);
        List<VideoOptionModel> list = new ArrayList<>();


        //设置RTSP 连接方式
        VideoOptionModel videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "rtsp_transport", "tcp");
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "rtsp_flags", "prefer_tcp");
        list.add(videoOptionModel);

        //硬解码：1、打开，0、关闭
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_PLAYER, "mediacodec", 1);
        list.add(videoOptionModel);

        //软解码：1、打开，0、关闭
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_PLAYER, "videotoolbox", 1);
        list.add(videoOptionModel);

        //根据媒体类型来配置
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "allowed_media_types", "video");
        list.add(videoOptionModel);

        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "timeout", 20000);
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "buffer_size", 1316);
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "infbuf", 1);  // 无限读
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "analyzemaxduration", 100);
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "probesize", 10240);
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "flush_packets", 1);
        list.add(videoOptionModel);
        //  关闭播放器缓冲，这个必须关闭，否则会出现播放一段时间后，一直卡主，控制台打印 FFP_MSG_BUFFERING_START
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_PLAYER, "packet-buffering", 0);
        list.add(videoOptionModel);

        GSYVideoManager.instance().setOptionModelList(list);


        String url = "rtsp://admin:huawei@123@192.168.11.20/LiveMedia/ch1/Media1";

        String ur2 = "rtsp://admin:huawei@123@192.168.11.21/LiveMedia/ch1/Media1";


        videoPlayer1.setPlayTag("videoPlayer1");
        videoPlayer1.setPlayPosition(1);



        videoPlayer2.setPlayTag("videoPlayer2");
        videoPlayer2.setPlayPosition(2);


        boolean isPlaying = videoPlayer1.getCurrentPlayer().isInPlayingState();
        boolean isPlaying2 = videoPlayer2.getCurrentPlayer().isInPlayingState();

        if (!isPlaying){
            videoPlayer1.setUpLazy(url, false, null, null, "");
        }


        if (!isPlaying2){
            videoPlayer2.setUpLazy(url, false, null, null, "");
        }

        videoPlayer1.getTitleTextView().setVisibility(View.GONE);
        videoPlayer2.getTitleTextView().setVisibility(View.GONE);

        videoPlayer1.getBackButton().setVisibility(View.GONE);
        videoPlayer2.getBackButton().setVisibility(View.GONE);


        videoPlayer2.setRotateViewAuto(true);
        videoPlayer2.setLockLand(true);
        videoPlayer2.setReleaseWhenLossAudio(false);
        videoPlayer2.setShowFullAnimation(true);
        videoPlayer2.setIsTouchWiget(false);
        videoPlayer2.setNeedLockFull(true);


        videoPlayer1.setRotateViewAuto(true);
        videoPlayer1.setLockLand(true);
        videoPlayer1.setReleaseWhenLossAudio(false);
        videoPlayer1.setShowFullAnimation(true);
        videoPlayer1.setIsTouchWiget(false);
        videoPlayer1.setNeedLockFull(true);

        videoPlayer1.startPlayLogic();
        videoPlayer2.startPlayLogic();




//        videoPlayer1.setVideoAllCallBack(new GSYSampleCallBack() {
//
//
//            @Override
//            public void onQuitFullscreen(String url, Object... objects) {
//                super.onQuitFullscreen(url, objects);
//              //  fullKey = "null";
//            }
//
//            @Override
//            public void onEnterFullscreen(String url, Object... objects) {
//                super.onEnterFullscreen(url, objects);
//                videoPlayer1.getCurrentPlayer().getTitleTextView().setText((String) objects[0]);
//                //fullKey = holder.gsyVideoPlayer.getKey();
//            }
//
//            @Override
//            public void onAutoComplete(String url, Object... objects) {
//                super.onAutoComplete(url, objects);
//            }
//        });



        //过渡动画


        if (CustomManager.instance().size() >= 0) {
            Map<String, CustomManager> map = CustomManager.instance();
            List<String> removeKey = new ArrayList<>();
            for (Map.Entry<String, CustomManager> customManagerEntry : map.entrySet()) {
                CustomManager customManager = customManagerEntry.getValue();
                //当前播放的位置
                int position = customManager.getPlayPosition();
                //对应的播放列表TAG
               // if (customManager.getPlayTag().equals(ListMultiNormalAdapter.TAG) && (position < firstVisibleItem || position > lastVisibleItem)) {
                    CustomManager.releaseAllVideos(customManagerEntry.getKey());
                    removeKey.add(customManagerEntry.getKey());
               // }
            }

            if(removeKey.size() > 0) {
                for (String key : removeKey) {
                    map.remove(key);
                }
                //listMultiNormalAdapter.notifyDataSetChanged();
            }
        }
    }


    private boolean isPause;

//    @Override
//    public void onBackPressed() {
//        if (CustomManager.backFromWindowFull(this, listMultiNormalAdapter.getFullKey())) {
//            return;
//        }
//        super.onBackPressed();
//    }

    @Override
    protected void onPause() {
        super.onPause();
        CustomManager.onPauseAll();
        isPause = true;
    }

    @Override
    protected void onResume() {
        super.onResume();
        CustomManager.onResumeAll();
        isPause = false;
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        CustomManager.clearAllVideo();
    }

}
